#pragma once
#include "pandaAlgorithm.h"
#include <vector>
#include <map>
#include <string>

using namespace std;

class PANDAALGORITHM_API OptScheduling
{
public:
	explicit OptScheduling();
	virtual ~OptScheduling();

	/**
		ˮò
	*/
	struct PumpStruct
	{
		double a; // ϵ
		std::vector<double> mS1; // iվĻ
		std::vector<double> mS2; // iվĵȵ
		std::vector<std::vector<int>> mNS; // iվjֱõĿ̨
		std::vector<std::vector<double>> mQS; // iվjбõĹˮ
		std::vector<std::vector<double>> mHS;// iվjˮõļ
		std::vector<std::vector< double>> mY;// iվjˮõļЧʣˮQvϵʽ
		std::vector<std::vector< double>> mX; // iվjˮûĴЧ
		std::vector<int> mK;  // iվжٱǫ̃
		std::vector<int> mP; //iվеٱǫ̃
	};

	/**
	* @brief Ŀ꺯Ӧֵ
	* @param [in] monitorVals
	*/
	virtual double objectiveFunction(float cost, const map<string,double>& monitorVals);

	/**
	* @brief ѹ
	* @param [in] HC[i]: ѹiԤѹֵ
	* @param [in] HF[I]: ѹiҪ͹ˮѹ
	* @return 
	*/
	virtual double pressureDifference(const vector<double>& HC,const vector<double>& HF);

	/**
	* @brief ˮùˮ
	* @param 
	* @param
	* @return 
	*/
	virtual double pumpPower(const PumpStruct& pumpParam);

	/**
	* @brief ˮɱ
	* @param 
	* @param
	* @return 
	*/
	virtual double waterProductionCost(const vector<double>& Q,const vector<double>& S3);

	/**
	* @brief ˮ
	* @param [vector<double>] Q[i]  i վȹˮ
	* @param [double] Qd ˮԤ
	* @return
	*/
	virtual double waterSupplyAndDemand(const vector<double>& Q, const double& Qd  );

	// üֵ
	void setMaxMonitorVals(const  map<string, double>& maxMonitors);

	// üСֵ
	void setMinMonitorsVals(const map<string, double>& minMonitors);

protected:

	// ͷ1
	double C1;

	// ͷ2
	double C2; 

	// õļĵֵ
	map<string, double> mMaxMonitorVals;

	// õļĵСֵ
	map<string, double> mMinMonitorVals;
};