#include "CivPumpHelper.h"
#include "CivPgDbConnection.h"

CivPumpHelper::CivPumpHelper(const string& uri)
{
	mConn = new CivPgDbConnection();
	mConn->connect(uri);
}

CivPumpHelper::~CivPumpHelper()
{
	mConn->disconnect();
	delete mConn;
}

void CivPumpHelper::getMap(const string& key, const string& val, map<string, string>& res)
{
	vector<map<string, string>> vecMap;
	if (!mConn->query(mTable, { key ,val }, vecMap))
		return;

	if (vecMap.size() <= 0)
		return;

	size_t total = vecMap.size();
	for (int i = 0; i < total; i++)
	{
		map<string, string> tempMap = vecMap[i];

		string keyVal = tempMap.find(key)->second;
		string valVal = tempMap.find(val)->second;

		res.insert(pair<string, string>(keyVal, valVal));
	}
}

int CivPumpHelper::getPumpNumbers()
{
	string sql = "select count(id) as cunt from " + mTable;
	if (!mConn->execSql(sql))
		return 0;

	vector<map<string,string>> pumpRes;
	if (!mConn->queryResult(pumpRes))
		return 0;

	if (pumpRes.size() <= 0)
		return 0;

	map<string, string> pumpMap = pumpRes[0];
	map<string, string>::iterator iter = pumpMap.find("cunt");
	if (iter == pumpMap.end())
		return 0;

	string pumpSize = iter->second;
	int pumps = atoi(pumpSize.c_str());
	return pumps;
}

void CivPumpHelper::getPumpSn(vector<string>& pumpNames)
{
	const string sz = "";
	vector<map<string, string>> vecMap;
	if (!mConn->query(mTable, { sz }, vecMap))
		return;

	if (vecMap.size() <= 0)
		return;

	size_t total = vecMap.size();
	for (int i = 0; i < total; i++)
	{
		map<string, string> tempMap = vecMap[i];
		string val = tempMap.find(sz)->second;
		pumpNames.push_back(val);
	}
}
